/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"time"
)

// checks if the AuthenticationProviderRegistration type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AuthenticationProviderRegistration{}

// AuthenticationProviderRegistration struct for AuthenticationProviderRegistration
type AuthenticationProviderRegistration struct {
	ApplicationId            *string        `json:"applicationId,omitempty"`
	JsonSchemaId             *string        `json:"jsonSchemaId,omitempty"`
	AuthenticationProviderId NullableString `json:"authenticationProviderId,omitempty"`
	RegistrationName         NullableString `json:"registrationName,omitempty"`
	Id                       NullableString `json:"id,omitempty"`
	CreationTime             *time.Time     `json:"creationTime,omitempty"`
}

// NewAuthenticationProviderRegistration instantiates a new AuthenticationProviderRegistration object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAuthenticationProviderRegistration() *AuthenticationProviderRegistration {
	this := AuthenticationProviderRegistration{}
	return &this
}

// NewAuthenticationProviderRegistrationWithDefaults instantiates a new AuthenticationProviderRegistration object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAuthenticationProviderRegistrationWithDefaults() *AuthenticationProviderRegistration {
	this := AuthenticationProviderRegistration{}
	return &this
}

// GetApplicationId returns the ApplicationId field value if set, zero value otherwise.
func (o *AuthenticationProviderRegistration) GetApplicationId() string {
	if o == nil || IsNil(o.ApplicationId) {
		var ret string
		return ret
	}
	return *o.ApplicationId
}

// GetApplicationIdOk returns a tuple with the ApplicationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuthenticationProviderRegistration) GetApplicationIdOk() (*string, bool) {
	if o == nil || IsNil(o.ApplicationId) {
		return nil, false
	}
	return o.ApplicationId, true
}

// HasApplicationId returns a boolean if a field has been set.
func (o *AuthenticationProviderRegistration) HasApplicationId() bool {
	if o != nil && !IsNil(o.ApplicationId) {
		return true
	}

	return false
}

// SetApplicationId gets a reference to the given string and assigns it to the ApplicationId field.
func (o *AuthenticationProviderRegistration) SetApplicationId(v string) {
	o.ApplicationId = &v
}

// GetJsonSchemaId returns the JsonSchemaId field value if set, zero value otherwise.
func (o *AuthenticationProviderRegistration) GetJsonSchemaId() string {
	if o == nil || IsNil(o.JsonSchemaId) {
		var ret string
		return ret
	}
	return *o.JsonSchemaId
}

// GetJsonSchemaIdOk returns a tuple with the JsonSchemaId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuthenticationProviderRegistration) GetJsonSchemaIdOk() (*string, bool) {
	if o == nil || IsNil(o.JsonSchemaId) {
		return nil, false
	}
	return o.JsonSchemaId, true
}

// HasJsonSchemaId returns a boolean if a field has been set.
func (o *AuthenticationProviderRegistration) HasJsonSchemaId() bool {
	if o != nil && !IsNil(o.JsonSchemaId) {
		return true
	}

	return false
}

// SetJsonSchemaId gets a reference to the given string and assigns it to the JsonSchemaId field.
func (o *AuthenticationProviderRegistration) SetJsonSchemaId(v string) {
	o.JsonSchemaId = &v
}

// GetAuthenticationProviderId returns the AuthenticationProviderId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AuthenticationProviderRegistration) GetAuthenticationProviderId() string {
	if o == nil || IsNil(o.AuthenticationProviderId.Get()) {
		var ret string
		return ret
	}
	return *o.AuthenticationProviderId.Get()
}

// GetAuthenticationProviderIdOk returns a tuple with the AuthenticationProviderId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AuthenticationProviderRegistration) GetAuthenticationProviderIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.AuthenticationProviderId.Get(), o.AuthenticationProviderId.IsSet()
}

// HasAuthenticationProviderId returns a boolean if a field has been set.
func (o *AuthenticationProviderRegistration) HasAuthenticationProviderId() bool {
	if o != nil && o.AuthenticationProviderId.IsSet() {
		return true
	}

	return false
}

// SetAuthenticationProviderId gets a reference to the given NullableString and assigns it to the AuthenticationProviderId field.
func (o *AuthenticationProviderRegistration) SetAuthenticationProviderId(v string) {
	o.AuthenticationProviderId.Set(&v)
}

// SetAuthenticationProviderIdNil sets the value for AuthenticationProviderId to be an explicit nil
func (o *AuthenticationProviderRegistration) SetAuthenticationProviderIdNil() {
	o.AuthenticationProviderId.Set(nil)
}

// UnsetAuthenticationProviderId ensures that no value is present for AuthenticationProviderId, not even an explicit nil
func (o *AuthenticationProviderRegistration) UnsetAuthenticationProviderId() {
	o.AuthenticationProviderId.Unset()
}

// GetRegistrationName returns the RegistrationName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AuthenticationProviderRegistration) GetRegistrationName() string {
	if o == nil || IsNil(o.RegistrationName.Get()) {
		var ret string
		return ret
	}
	return *o.RegistrationName.Get()
}

// GetRegistrationNameOk returns a tuple with the RegistrationName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AuthenticationProviderRegistration) GetRegistrationNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.RegistrationName.Get(), o.RegistrationName.IsSet()
}

// HasRegistrationName returns a boolean if a field has been set.
func (o *AuthenticationProviderRegistration) HasRegistrationName() bool {
	if o != nil && o.RegistrationName.IsSet() {
		return true
	}

	return false
}

// SetRegistrationName gets a reference to the given NullableString and assigns it to the RegistrationName field.
func (o *AuthenticationProviderRegistration) SetRegistrationName(v string) {
	o.RegistrationName.Set(&v)
}

// SetRegistrationNameNil sets the value for RegistrationName to be an explicit nil
func (o *AuthenticationProviderRegistration) SetRegistrationNameNil() {
	o.RegistrationName.Set(nil)
}

// UnsetRegistrationName ensures that no value is present for RegistrationName, not even an explicit nil
func (o *AuthenticationProviderRegistration) UnsetRegistrationName() {
	o.RegistrationName.Unset()
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AuthenticationProviderRegistration) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AuthenticationProviderRegistration) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *AuthenticationProviderRegistration) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *AuthenticationProviderRegistration) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *AuthenticationProviderRegistration) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *AuthenticationProviderRegistration) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *AuthenticationProviderRegistration) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuthenticationProviderRegistration) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *AuthenticationProviderRegistration) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *AuthenticationProviderRegistration) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o AuthenticationProviderRegistration) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AuthenticationProviderRegistration) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ApplicationId) {
		toSerialize["applicationId"] = o.ApplicationId
	}
	if !IsNil(o.JsonSchemaId) {
		toSerialize["jsonSchemaId"] = o.JsonSchemaId
	}
	if o.AuthenticationProviderId.IsSet() {
		toSerialize["authenticationProviderId"] = o.AuthenticationProviderId.Get()
	}
	if o.RegistrationName.IsSet() {
		toSerialize["registrationName"] = o.RegistrationName.Get()
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

type NullableAuthenticationProviderRegistration struct {
	value *AuthenticationProviderRegistration
	isSet bool
}

func (v NullableAuthenticationProviderRegistration) Get() *AuthenticationProviderRegistration {
	return v.value
}

func (v *NullableAuthenticationProviderRegistration) Set(val *AuthenticationProviderRegistration) {
	v.value = val
	v.isSet = true
}

func (v NullableAuthenticationProviderRegistration) IsSet() bool {
	return v.isSet
}

func (v *NullableAuthenticationProviderRegistration) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAuthenticationProviderRegistration(val *AuthenticationProviderRegistration) *NullableAuthenticationProviderRegistration {
	return &NullableAuthenticationProviderRegistration{value: val, isSet: true}
}

func (v NullableAuthenticationProviderRegistration) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAuthenticationProviderRegistration) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
